; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	call LCD_ZEILE1		; ZEILE1
	LDS temp1,(adr_TASTE)
	tst temp1
	breq MENUE_RUN
	call LCD_CLEAR
;-------------------------------------------------------------------------------
MENUE_p:
	LDS temp1,(adr_TASTE)
	cpi temp1,(TASTE_MENUE_PLUS)
	brne MENUE_m
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_m:
	cpi temp1,(TASTE_MENUE_MINUS)
	brne MENUE_RUN
	LDS temp,(adr_MENUE)
	tst temp
	breq MENUE_RUN
	dec temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL, LOW(MENUE_SPRUNGMARKE)	; Z		
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	LSL temp	; x2, wegen "jmp (2 Words)"	
	add ZL,temp
	adc ZH,NULL
	IJMP	; SPRUNG nach Z
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	jmp MENUE_SEKTOR_READ
	jmp MENUE_SPUR_NULL
	jmp MENUE_SPUR_20
	jmp MENUE_SPUR_STEP
	jmp MENUE_SPUR_STEP10
	jmp MENUE_MOTOR_ON_OFF
	jmp MENUE_SELECT_HEAD
	jmp MENUE_SELECT_FLOPPY
	jmp MENUE_FLOPPY_PINS
	jmp MENUE_FLOPPY_STATUS
	jmp MENUE_RPM
	jmp MENUE_IMULSE_PRO_UMDREHUNG
	jmp MENUE_SYSTEM
	jmp LCD_ANZEIGE_BEGRUESSUNG
	jmp MENUE_WARNUNG
	jmp MENUE_DATA_WRITE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	STS(adr_MENUE),NULL
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BAUSTELLE:
	call TEXT_BAUSTELLE
	call LCD_ZEILE2
	call LCD_DOPPEL_PUNKT_SPACE
	LDS temp1,(adr_MENUE)
	call LCD_ZAHL_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SEKTOR_READ:
	call TEXT_SEKTOR
	call TEXT_READ
	call LCD_ZEILE3	
	call LCD_ANZEIGE_HEAD
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_SEKTOR_READ_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SEKTOR_READ_RUN:
	call LCD_CLEAR
	call TEXT_WAIT
	call MFM_ZEIT
MENUE_SEKTOR_READ_s:
	call TASTEN_ABFRAGE
	LDS temp,(adr_TASTE)
	tst temp
	breq MENUE_SEKTOR_READ_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_MOTOR_ON_OFF:
	call TEXT_MOTOR_ON_OFF
	LDS temp1,(adr_FLOPPY_MOTOR_ON)
	call LCD_ZAHL1_TEMP1
	call TASTE_PLUS_C
	brcs MENUE_MOTOR_ON_OFF_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_MOTOR_ON_OFF_RUN:
	call LCD_CLEAR
	call TEXT_WAIT
	LDS temp,(adr_FLOPPY_MOTOR_ON)
	tst temp
	breq MENUE_MOTOR_ON_OFF_w
	call FLOPPY_MOTOR_OFF
	call LCD_CLEAR
	ret
MENUE_MOTOR_ON_OFF_w:
	call FLOPPY_MOTOR_ON
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SELECT_FLOPPY:
	call TEXT_FLOPPY
	LDS temp1,(adr_FLOPPY_SELECT)
	call LCD_ZAHL_TEMP1
	call TASTE_PLUS_C
	brcs MENUE_SELECT_FLOPPY_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SELECT_FLOPPY_RUN:
	call LCD_CLEAR	
	call TEXT_WAIT
	call FLOPPY_MOTOR_OFF
	LDS  temp,(adr_FLOPPY_SELECT)
	inc temp
	andi temp,0b00000001
	STS(adr_FLOPPY_SELECT),temp
	call FLOPPY_MOTOR_ON
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SELECT_HEAD:
	call TEXT_HEAD
	LDS temp1,(adr_FLOPPY_HEAD)
	call LCD_ZAHL_TEMP1
	call TASTE_PLUS_C
	brcs MENUE_SELECT_HEAD_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SELECT_HEAD_RUN:
	call LCD_CLEAR	
	call TEXT_WAIT
	call WAIT_200ms
	LDS  temp,(adr_FLOPPY_HEAD)
	inc temp
	andi temp,0b00000001
	STS(adr_FLOPPY_HEAD),temp
	tst temp
	brne MENUE_SELECT_HEAD_1
MENUE_SELECT_HEAD_0:
	call FLOPPY_HEAD0
	rjmp LCD_CLEAR
MENUE_SELECT_HEAD_1:
	call FLOPPY_HEAD1
	rjmp LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SPUR_NULL:
	call TEXT_SPUR
	call TEXT_NULL
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_SPUR_NULL_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SPUR_NULL_RUN:
	rcall LCD_CLEAR
	rcall TEXT_WAIT
	rcall FLOPPY_POS_NULL
	rcall WAIT_200ms
	rcall FLOPPY_STEP_PLUS10
	rcall WAIT_200ms
	rcall FLOPPY_POS_NULL
	rcall LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SPUR_20:
	call TEXT_SPUR
	call LCD_2
	call LCD_0
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_SPUR_20_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SPUR_20_RUN:
	rcall LCD_CLEAR
	rcall TEXT_WAIT
	rcall FLOPPY_MOTOR_ON
	rcall FLOPPY_POS_NULL
	rcall FLOPPY_STEP_PLUS10
	rcall FLOPPY_STEP_PLUS10
	rcall LCD_CLEAR
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SPUR_STEP:
	call TEXT_SPUR
	call TEXT_STEP
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_SPUR_STEP_P
	call TASTE_MINUS_C
	brcs MENUE_SPUR_STEP_M
	ret
;-------------------------------------------------------------------------------
MENUE_SPUR_STEP_P:
	call LCD_CLEAR
	call TEXT_WAIT
	call FLOPPY_STEP_PLUS
	call LCD_CLEAR
ret
;-------------------------------------------------------------------------------
MENUE_SPUR_STEP_M:
	call LCD_CLEAR
	call TEXT_WAIT
	call FLOPPY_STEP_MINUS
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SPUR_STEP10:
	call TEXT_SPUR
	call TEXT_STEP
	call LCD_1
	call LCD_0
	call LCD_ZEILE4
	call LCD_ANZEIGE_SPUR
	call TASTE_PLUS_C
	brcs MENUE_SPUR_STEP10_P
	call TASTE_MINUS_C
	brcs MENUE_SPUR_STEP10_M
	ret
;-------------------------------------------------------------------------------
MENUE_SPUR_STEP10_P:
	rjmp FLOPPY_STEP_PLUS10
MENUE_SPUR_STEP10_M:
	rjmp FLOPPY_STEP_MINUS10
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_RPM:
	call TEXT_RPM
	call TASTE_PLUS_C
	brcs MENUE_RPM_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_RPM_RUN:
	call TIMER3_INITIALISIERUNG
	call LCD_CLEAR
	call TEXT_WAIT
	call FLOPPY_MOTOR_ON
	call FLOPPY_WAIT_INDEX_HIGH
	call FLOPPY_WAIT_INDEX_LOW
	call FLOPPY_WAIT_INDEX_HIGH
	call FLOPPY_WAIT_INDEX_LOW
	call FLOPPY_WAIT_INDEX_HIGH
	call FLOPPY_WAIT_INDEX_LOW
	call FLOPPY_WAIT_INDEX_HIGH
	call UHR_NULL
	clr ZL
	clr ZH
MENUE_RPM_s:
	call FLOPPY_WAIT_INDEX_LOW
	call FLOPPY_WAIT_INDEX_HIGH
	call LCD_ZEILE2		; ZEILE 
	call LCD_ANZEIGE_ZEIT
	call LCD_ZEILE3		; ZEILE 
	adiw ZL,1
	mov temp1,ZL
	mov temp2,ZH
	call LCD_ZAHL_TEMP1_2
	LDS temp,(adr_mm)
	tst temp
	breq MENUE_RPM_s
	call LCD_ZEILE4		; ZEILE 
	call TEXT_FERTIG
	call FLOPPY_MOTOR_OFF
	call TIMER3_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Ergebnis: ca. 75.530...91.000 Imp/min													
MENUE_IMULSE_PRO_UMDREHUNG:
	call TEXT_IMP_PRO_UMDREHUNG
	call TASTE_PLUS_C
	brcs MENUE_IMULSE_PRO_UMDREHUNG_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_IMULSE_PRO_UMDREHUNG_RUN:
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	call LCD_CLEAR
	call TEXT_WAIT
	call FLOPPY_MOTOR_ON
	call FLOPPY_WAIT_INDEX_HIGH
	call FLOPPY_WAIT_INDEX_LOW
	call FLOPPY_WAIT_INDEX_HIGH
	call FLOPPY_WAIT_INDEX_LOW
	call FLOPPY_WAIT_INDEX_HIGH
	call FLOPPY_WAIT_INDEX_LOW
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an
;-------------------------------------------------------------------------------
MENUE_IMP_s1:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN high	
	rjmp MENUE_IMP_s1
;-------------------------------------------------------------------------------
MENUE_IMP_s2:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN LOW	
	rjmp MENUE_IMP_s2
;-------------------------------------------------------------------------------
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
;-------------------------------------------------------------------------------
	sbis (INDEX_PIN),(INDEX_PIN_NR)		; Schleife bis INDEX high		
	rjmp MENUE_IMP_s1
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
MENUE_IMP_s3:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN high	
	rjmp MENUE_IMP_s3
;-------------------------------------------------------------------------------
MENUE_IMP_s4:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN LOW	
	rjmp MENUE_IMP_s4
;-------------------------------------------------------------------------------
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
;-------------------------------------------------------------------------------
	sbic (INDEX_PIN),(INDEX_PIN_NR)		; Schleife bis INDEX low		
	rjmp MENUE_IMP_s3
;-------------------------------------------------------------------------------
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB aus	
	call LCD_ZEILE2		; ZEILE 
	call LCD_ZAHL_TEMP1_2_3_4
	call FLOPPY_MOTOR_OFF
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_FLOPPY_STATUS:
	call TEXT_FLOPPY
	call TEXT_STATUS

	call LCD_ZEILE2
	call LCD_T
	call LCD_R
	call LCD_0
	call LCD_0
	call LCD_SPACE
	sbis (TRK00_PIN),(TRK00_PIN_NR)
	rcall LCD_L
	sbic (TRK00_PIN),(TRK00_PIN_NR)
	rcall LCD_H


	call LCD_ZEILE3
	call LCD_W
	call LCD_R
	call LCD_P
	call LCD_T
	call LCD_SPACE
	sbis (WRPT_PIN),(WRPT_PIN_NR)
	rcall LCD_L
	sbic (WRPT_PIN),(WRPT_PIN_NR)
	rcall LCD_H

	call LCD_ZEILE4
	call LCD_D
	call LCD_s
	call LCD_k
	call LCD_C
	call LCD_SPACE
	sbis (DSKCHG_PIN),(DSKCHG_PIN_NR)
	rcall LCD_L
	sbic (DSKCHG_PIN),(DSKCHG_PIN_NR)
	rcall LCD_H

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SYSTEM:
	call TEXT_SYSTEM

	call LCD_ZEILE2
	call LCD_S
	call LCD_R
	call LCD_A
	call LCD_M
	call LCD_SPACE
	ldi ZL,low (RAMEND)
	ldi ZH,high(RAMEND)
	ldi XL, LOW (SRAM_START)
	ldi XH, HIGH(SRAM_START)
	sub ZL,XL
	sbc ZH,XH
	mov temp1,ZL
	mov temp2,ZH
	call LCD_ZAHL_TEMP1_2

	call LCD_ZEILE3
	call LCD_D
	call LCD_A
	call LCD_T
	call LCD_A
	call LCD_SPACE
	ldi ZL,low (adr_SRAM_CHECK)
	ldi ZH,high(adr_SRAM_CHECK)
	ldi XL, LOW (adr_DATA)
	ldi XH, HIGH(adr_DATA)
	sub ZL,XL
	sbc ZH,XH
	mov temp1,ZL
	mov temp2,ZH
	call LCD_ZAHL_TEMP1_2

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_WARNUNG:
	call TEXT_WARNUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_DATA_WRITE:
	call TEXT_DATA
	call TEXT_WRITE
	call LCD_ZEILE2		; ZEILE 	
	call TEXT_WARNUNG
	call TASTE_PLUS_C
	brcs MENUE_DATA_WRITE_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_DATA_WRITE_RUN:
	call TEXT_WAIT
	call FLOPPY_WRITE
	call LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_FLOPPY_PINS:
	call TEXT_FLOPPY
	call TEXT_PINS
	call LCD_ZEILE2

	call LCD_ZEILE3
.equ ASCII_L='*'
.equ ASCII_H='-'
;2-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (DENSITY_PIN),(DENSITY_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;4-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (NC0_PIN),(NC0_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;6-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (NC1_PIN),(NC1_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;8-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (INDEX_PIN),(INDEX_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;10-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (MOTENA_PIN),(MOTENA_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;12-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (DRVSB_PIN),(DRVSB_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;14-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (DRVSA_PIN),(DRVSA_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;16-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (MOTENB_PIN),(MOTENB_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP	
;18-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (DIR_PIN),(DIR_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;20-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (STEP_PIN),(STEP_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;---------------------------------------------------------------------------------
	call LCD_SPACE
	call LCD_2
	call LCD_MINUS
	call LCD_2
	call LCD_0
	call LCD_ZEILE4					; Zeile
;22-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (WRDATA_PIN),(WRDATA_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;24-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (WREN_PIN),(WREN_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;26-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (TRK00_PIN),(TRK00_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;28-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (WRPT_PIN),(WRPT_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;30-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;32-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (HEAD1_PIN),(HEAD1_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;34-------------------------------------------------------------------------------
	ldi temp,ASCII_H
	sbis (DSKCHG_PIN),(DSKCHG_PIN_NR)
	ldi temp,ASCII_L
	call LCD_DATA_TEMP
;34-------------------------------------------------------------------------------
	call LCD_SPACE3
	call LCD_2
	call LCD_2
	call LCD_MINUS
	call LCD_3
	call LCD_2
ret





















