; (2,PC2)DENSITY
.equ DENSITY_PIN_NR			= 2
.equ DENSITY_PIN			= PINC
; (4,PC3)nc		
.equ NC0_PIN_NR				= 3
.equ NC0_PIN				= PINC
; (6,PC4)nc		
.equ NC1_PIN_NR				= 4
.equ NC1_PIN				= PINC
; (8,PC5)INDEX 	
.equ INDEX_PIN_NR			= 5
.equ INDEX_PIN				= PINC
; (10,PC6) MOTOR-A	
.equ MOTENA_PIN_NR			= 6
.equ MOTENA_DDR				= DDRC
.equ MOTENA_PORT			= PORTC
.equ MOTENA_PIN				= PINC
; (12,PC7)DRVSB	
.equ DRVSB_PIN_NR			= 7
.equ DRVSB_DDR				= DDRC
.equ DRVSB_PORT				= PORTC
.equ DRVSB_PIN				= PINC
; (14,PD7)DRVSA	
.equ DRVSA_PIN_NR			= 7
.equ DRVSA_DDR				= DDRD
.equ DRVSA_PORT				= PORTD
.equ DRVSA_PIN				= PIND
; (16,PB1) MOTOR-B	
.equ MOTENB_PIN_NR			= 1
.equ MOTENB_DDR				= DDRB
.equ MOTENB_PORT			= PORTB
.equ MOTENB_PIN				= PINB
; (18,PB0)DIR	
.equ DIR_PIN_NR				= 0
.equ DIR_DDR				= DDRB
.equ DIR_PORT				= PORTB
.equ DIR_PIN				= PINB
; (20,PA7)STEP	
.equ STEP_PIN_NR			= 7
.equ STEP_DDR				= DDRA
.equ STEP_PORT				= PORTA
.equ STEP_PIN				= PINA
; (22,PA6)WRDATA
.equ WRDATA_PIN_NR			= 6
.equ WRDATA_DDR				= DDRA
.equ WRDATA_PORT			= PORTA
.equ WRDATA_PIN				= PINA
; (24,PA5)WREN
.equ WREN_PIN_NR			= 5
.equ WREN_DDR				= DDRA
.equ WREN_PORT				= PORTA
.equ WREN_PIN				= PINA
; (26,PA4)TRK00
.equ TRK00_PIN_NR			= 4
.equ TRK00_PIN				= PINA
; (28,PA3)WRPT
.equ WRPT_PIN_NR			= 3
.equ WRPT_PIN				= PINA
; (30,PA2)RDDATA
.equ RDDATA_PIN_NR			= 2
.equ RDDATA_PIN				= PINA
; (32,PA1)HEAD1
.equ HEAD1_PIN_NR			= 1
.equ HEAD1_DDR				= DDRA
.equ HEAD1_PORT				= PORTA
.equ HEAD1_PIN				= PINA
; (34,PA0)DSKCHG
.equ DSKCHG_PIN_NR			= 0
.equ DSKCHG_PIN				= PINA
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_INITIALISIERUNG:
	; Auf Ausgang					
	sbi (MOTENA_DDR),(MOTENA_PIN_NR); MOTOR-A	
	sbi (MOTENB_DDR),(MOTENB_PIN_NR); MOTOR-B	
	sbi (DRVSA_DDR),(DRVSA_PIN_NR)	; DRVS-A	
	sbi (DRVSB_DDR),(DRVSB_PIN_NR)	; DRVS-B	
	sbi (STEP_DDR),(STEP_PIN_NR)	; STEP		
	sbi (DIR_DDR),(DIR_PIN_NR)		; DIR		
	sbi (HEAD1_DDR),(HEAD1_PIN_NR)	; HEAD1		
	sbi (WREN_DDR),(WREN_PIN_NR)	; WREN		
	sbi (WRDATA_DDR),(WRDATA_PIN_NR); WRDATA	

;	STS(adr_FLOPPY_A_B),NULL		; Motor-A	
;	rcall FLOPPY_MOTOR_ON
;	rcall FLOPPY_MOTOR_OFF
;	STS(adr_FLOPPY_A_B),EINS		; Motor-B	
;	rcall FLOPPY_MOTOR_ON
;	rcall FLOPPY_MOTOR_OFF
;	STS(adr_FLOPPY_A_B),NULL		; Motor-A	
;-------------------------------------------------------------------------------
	rcall LCD_CLEAR
	rcall TEXT_WAIT
	STS(adr_FLOPPY_SELECT),EINS		; Motor-B	
	call FLOPPY_MOTOR_ON
	rcall FLOPPY_POS_NULL
	rcall FLOPPY_STEP_PLUS10
	rcall FLOPPY_STEP_PLUS10
	rcall FLOPPY_MOTOR_OFF
	rcall LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_MOTOR_ON:
	LDS temp,(adr_FLOPPY_MOTOR_ON)
	tst temp
	breq FLOPPY_MOTOR_ON_RUN
	ret
;-------------------------------------------------------------------------------
FLOPPY_MOTOR_ON_RUN:
	STS(adr_FLOPPY_MOTOR_ON),EINS
	LDS temp,(adr_FLOPPY_SELECT)
	tst temp
	brne FLOPPY_MOTORB_ON
;-------------------------------------------------------------------------------
FLOPPY_MOTORA_ON:
	cbi (MOTENA_PORT),(MOTENA_PIN_NR)		; Enable 	
	cbi (DRVSA_PORT),(DRVSA_PIN_NR)			; select, LED leuchtet	
	rcall WAIT_2s
	ret
;-------------------------------------------------------------------------------
FLOPPY_MOTORB_ON:
	cbi (MOTENB_PORT),(MOTENB_PIN_NR)		; Enable 	
	cbi (DRVSB_PORT),(DRVSB_PIN_NR)			; select, LED leuchtet	
	rcall WAIT_2s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_MOTOR_OFF:
	sbi (MOTENA_PORT),(MOTENA_PIN_NR)		; 
	sbi (DRVSA_PORT),(DRVSA_PIN_NR)			; select, LED aus		
	sbi (MOTENB_PORT),(MOTENB_PIN_NR)		; 
	sbi (DRVSB_PORT),(DRVSB_PIN_NR)			; select, LED aus		
	STS(adr_FLOPPY_MOTOR_ON),NULL
	rcall WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_POS_NULL:
	rcall FLOPPY_MOTOR_ON
FLOPPY_POS_NULL_s:
	rcall FLOPPY_STEP_MINUS
	sbic (TRK00_PIN),(TRK00_PIN_NR)
	rjmp FLOPPY_POS_NULL_s
	STS(adr_FLOPPY_SPUR),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_STEP_PLUS:
	rcall FLOPPY_MOTOR_ON
	LDS temp,(adr_FLOPPY_SPUR)
	inc temp
	STS(adr_FLOPPY_SPUR),temp

	cbi (DIR_PORT),(DIR_PIN_NR)			; DIR
	cbi (STEP_PORT),(STEP_PIN_NR)		; 
	rcall WAIT_10us
	sbi (STEP_PORT),(STEP_PIN_NR)		; 
	rcall WAIT_10ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_STEP_MINUS:
	rcall FLOPPY_MOTOR_ON
	LDS temp,(adr_FLOPPY_SPUR)
	dec temp
	STS(adr_FLOPPY_SPUR),temp

	sbi (DIR_PORT),(DIR_PIN_NR)			; DIR
	cbi (STEP_PORT),(STEP_PIN_NR)		; 
	rcall WAIT_10us
	sbi (STEP_PORT),(STEP_PIN_NR)		; 
	rcall WAIT_10ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_STEP_PLUS10:
	rcall FLOPPY_STEP_PLUS
	rcall FLOPPY_STEP_PLUS
	rcall FLOPPY_STEP_PLUS
	rcall FLOPPY_STEP_PLUS
	rcall FLOPPY_STEP_PLUS
	rcall FLOPPY_STEP_PLUS
	rcall FLOPPY_STEP_PLUS
	rcall FLOPPY_STEP_PLUS
	rcall FLOPPY_STEP_PLUS
	rcall FLOPPY_STEP_PLUS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_STEP_MINUS10:
	rcall FLOPPY_STEP_MINUS
	rcall FLOPPY_STEP_MINUS
	rcall FLOPPY_STEP_MINUS
	rcall FLOPPY_STEP_MINUS
	rcall FLOPPY_STEP_MINUS
	rcall FLOPPY_STEP_MINUS
	rcall FLOPPY_STEP_MINUS
	rcall FLOPPY_STEP_MINUS
	rcall FLOPPY_STEP_MINUS
	rcall FLOPPY_STEP_MINUS
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_HEAD0:
	sbi (HEAD1_PORT),(HEAD1_PIN_NR)			; 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_HEAD1:
	cbi (HEAD1_PORT),(HEAD1_PIN_NR)			; 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_WAIT_INDEX_HIGH:
	sbis (INDEX_PIN),(INDEX_PIN_NR)
	rjmp FLOPPY_WAIT_INDEX_HIGH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_WAIT_INDEX_LOW:
	sbic (INDEX_PIN),(INDEX_PIN_NR)
	rjmp FLOPPY_WAIT_INDEX_LOW
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FLOPPY_WRITE:
	rcall FLOPPY_WAIT_INDEX_HIGH
	rcall FLOPPY_WAIT_INDEX_LOW
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
	cbi (WREN_PORT),(WREN_PIN_NR)				; WREN on	
;-------------------------------------------------------------------------------
ldi temp9,255
FLOPPY_WRITE_s:
	cbi (WRDATA_PORT),(WRDATA_PIN_NR)				;
	rcall WAIT_2us
	sbi (WRDATA_PORT),(WRDATA_PIN_NR)				;
	rcall WAIT_2us
	dec temp9
	brne FLOPPY_WRITE_s
;-------------------------------------------------------------------------------
	sbi (WREN_PORT),(WREN_PIN_NR)				; WREN off	
	rcall WAIT_500ms
	sbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

